/** stationsearchwin.cpp
 * Ŋw
 *
 * @copyright	(c)studio pahoo
 * @author		ppςӂ
 * @J	MinGW C++ + cURL + OpenSSL + Boost C++ Libraries
 *					+ WebView2Loader.dll + Leaflet + OSM (+ GoogleMap)
 * @QlURL		https://www.pahoo.org/e-soul/webtech/cpp01/cpp01-15-01.shtm
 */
#include <iostream>
#include <fstream>
#include <stdio.h>
#include <stdlib.h>
#include <tchar.h>
#include <time.h>
#include <sstream>
#include <string>
#include <locale>
#include <regex>
#include <winsock2.h>
#include <windows.h>
#include <shlobj.h>
#include <commctrl.h>
#include <objbase.h>
#include <wrl.h>
#include <richedit.h>

#include <curl/curl.h>
#include <boost/format.hpp>
#include <boost/property_tree/xml_parser.hpp>
#include <boost/property_tree/json_parser.hpp>
#include <boost/algorithm/string.hpp>
#include "mystrings.h"
#include "apikey.h"
#include "WebView2.h"
#include "pahooWebView2.hpp"
#include "pahooGeocode.hpp"
#include "resource.h"

using namespace std;
using namespace boost;
using namespace boost::property_tree;

// 萔Ȃ ==================================================================
#define MAKER		"pahoo.org"				//쐬
#define APPNAME		"stationsearchwin"		//AvP[V
#define APPNAMEJP	"Ŋw"			//AvP[Vi{j
#define APPVERSION	"2.1.1"					//o[W
#define APPYEAR		"2020-24"				//쐬N
#define REFERENCE	"https://www.pahoo.org/e-soul/webtech/cpp01/cpp01-15-01.shtm"	//QlTCg

//ListViewItem̍ő啶FύXs
#define MAX_LISTVIEWITEM	259

//wvEt@C
#define HELPFILE	".\\etc\\help.chm"

//ftHgۑt@C
#define SAVEFILE	"stationsearchwin.csv"

//}bvID
#define MAP_ID			"map_id"
//n}̑傫
#define MAP_WIDTH		530		//n}̕isNZj
#define MAP_HEIGHT		300		//n}̍isNZj
//oxEܓxilj
#define DEF_LONGITUDE	139.766667
double Longitude = DEF_LONGITUDE;
#define DEF_LATITUDE	35.681111
double Latitude  = DEF_LATITUDE;
//n}g嗦ilj
#define DEF_ZOOM	13
int Zoom = DEF_ZOOM;
//n}̎ށilj
#define DEF_MAPTYPE		"GSISTD"
string Maptype = DEF_MAPTYPE;

//݂̃C^[tFCX
HINSTANCE hInst;

//AvP[VEEBhE
HWND hParent;

//WebView2EBhE
HWND hWebView2;

//ICoreWebView2FpahooWebView2.cpp Œ`D
extern ICoreWebView2* webView2;

//e|t@C
char tmpFname[MAX_PATH + 1];
wchar_t wUri[MAX_PATH * 2 + 1];

//AvP[VEEBhEʒu
unsigned hParent_X, hParent_Y;

//L[i[p
string Query;

//G[EbZ[Wi[pyύXsz
string ErrorMessage;

//UserAgent
string UserAgent;

//pahooGeocodeIuWFNg
pahooGeocode* pGC;

//WebView2nh̓w肷D
enum class eAction {
	GetLatLong,				//ܓxEox擾ăuEU\
	GetZoomType,			//g嗦E}bv^Cv擾ăuEU\
	GetLatLongZoomType,		//ܓxEoxEg嗦E}bv^Cv擾ăuEU\
	Finish					//vOI
};
eAction selectAction;

//o[W
string Version = (boost::format(R"(
%1%  o[W %2%

{AvP[VMIT LicensełD
p܂ޖp\łDRɉł܂D
Ĕzz̍ۂ́CL̒쌠\LCURLƖ{gpKLĂD

@Copyright by (c)studio pahoo, %3%
@https://www.pahoo.org/

ȂC{AvP[V̗p܂͉邱ƂɂĐĂ͈؊֒m܂DAPI̕ύXE~ɂĐɋ@\ȂȂꍇ܂D܂C񎟗p̑gDEƁEĉ̖ړIEeEɂĂ͈؊֒m܂D

{AvP[V́CL̃CuCt[[NCC^[lbg̃\[X𗘗pĂ܂D
@MinGWig++j^Boost C++Cu^libcurl^OpenSSL+^
@WebView2Loader.dll^Leaflet^OpenStreetMap^Google}bv^
@HeartRails Express
)")
% APPNAMEJP
% APPVERSION
% APPYEAR
).str();


// TuEvO =====================================================
/**
 * p[^̏
 * @param	Ȃ
 * @return	Ȃ
 */
void initParameter(void) {
	Query     = "";
	Longitude = DEF_LONGITUDE;
	Latitude  = DEF_LATITUDE;
	Zoom      = DEF_ZOOM;
	Maptype   = DEF_MAPTYPE;
	hParent_X = 0;
	hParent_Y = 0;
}

/**
 * p[^̓ǂݍ
 * @param	Ȃ
 * @return	Ȃ
 */
void loadParameter(void) {
	ptree pt;

	//lݒ
	initParameter();

	//XMLt@Cǂݍ
	try {
		xml_parser::read_xml(getMyPath(APPNAME) + APPNAME + ".xml", pt);

		//XML
		try {
			//``FbN
			if (optional<string>str = pt.get_optional<string>("parameter")) {
			} else {
				return;
			}
			//p[^ǂݍ
			for (auto it : pt.get_child("parameter")) {
				string type= it.second.get_optional<string>("<xmlattr>.type").value();
				if (type == "latitude") {
					Latitude = stod(it.second.data());
				} else if (type == "longitude") {
					Longitude = stod(it.second.data());
				} else if (type == "zoom") {
					Zoom = stoi(it.second.data());
				} else if (type == "maptype") {
					Maptype = (string)it.second.data();
				} else if (type == "wx") {
					hParent_X = (unsigned)stoi(it.second.data());
				} else if (type == "wy") {
					hParent_Y = (unsigned)stoi(it.second.data());
				} else if (type == "query") {
					Query = utf8_sjis((string)it.second.data());
				}
			}
		//ߎs珉lݒ
		} catch (xml_parser_error& e) {
			initParameter();
			return;
		}
	//ǂݍݎs珉lݒ
	} catch (xml_parser_error& e) {
		initParameter();
		return;
	}

	//AvP[VEEBhËʒuifXNgbv͈͊OȂ猴_ړj
	HWND hDesktop = GetDesktopWindow();
	WINDOWINFO windowInfo;
	windowInfo.cbSize = sizeof(WINDOWINFO);
	GetWindowInfo(hDesktop, &windowInfo);
	if (hParent_X >= (unsigned)windowInfo.rcWindow.right) {
		hParent_X = 0;
	}
	if (hParent_Y >= (unsigned)windowInfo.rcWindow.bottom) {
		hParent_Y = 0;
	}
}

/**
 * p[^̕ۑ
 * @param	Ȃ
 * @return	Ȃ
 */
void saveParameter(void) {
#ifndef CMDAPP
	//AvP[VEEBhËʒu擾
	WINDOWINFO windowInfo;
	windowInfo.cbSize = sizeof(WINDOWINFO);
	GetWindowInfo(hParent, &windowInfo);
	hParent_X = (unsigned)windowInfo.rcWindow.left;
	hParent_Y = (unsigned)windowInfo.rcWindow.top;
	if (hParent_X >= (unsigned)windowInfo.rcWindow.right) {
		hParent_X = 0;
	}
	if (hParent_Y >= (unsigned)windowInfo.rcWindow.bottom) {
		hParent_Y = 0;
	}
#endif

	char lng[SIZE_BUFF + 1], lat[SIZE_BUFF + 1];
	snprintf(lng, SIZE_BUFF, "%.5f", Longitude);
	snprintf(lat, SIZE_BUFF, "%.5f", Latitude);

	//XMLt@C֏
	ptree pt;
	ptree& child1 = pt.add("parameter.param", lat);
	child1.add("<xmlattr>.type", "latitude");
	ptree& child2 = pt.add("parameter.param", lng);
	child2.add("<xmlattr>.type", "longitude");
	ptree& child3 = pt.add("parameter.param", to_string(Zoom));
	child3.add("<xmlattr>.type", "zoom");
	ptree& child4 = pt.add("parameter.param", Maptype);
	child4.add("<xmlattr>.type", "maptype");
	ptree& child5 = pt.add("parameter.param", (string)to_string(hParent_X));
	child5.add("<xmlattr>.type", "wx");
	ptree& child6 = pt.add("parameter.param", (string)to_string(hParent_Y));
	child6.add("<xmlattr>.type", "wy");
	ptree& child7 = pt.add("parameter.param", sjis_utf8(Query));
	child7.add("<xmlattr>.type", "query");

	const int indent = 4;
	write_xml(getMyPath(APPNAME) + APPNAME + ".xml", pt, std::locale(),
		xml_writer_make_settings<std::string>(' ', indent));
}

/**
 * p[^̍폜
 * @param	Ȃ
 * @return	Ȃ
 */
void delParameter(void) {
	remove((getMyPath(APPNAME) + APPNAME + ".xml").c_str());

	//lݒ
	initParameter();
}

// WebAPIuHeartRails Expressv ==============================================

//Ŋw
typedef struct _pstations {
	char id;					//ʎq
	std::wstring title;			//w
	std::wstring line;			//Ŋw݂̑H
	std::wstring distance;		//w̏ꏊŊw܂ł̋ix10j
	double latitude;			//ܓx
	double longitude;			//ox
} pstations_t;

//NX`
class pahooHeartRailsExpress {

public:
//RXgN^
pahooHeartRailsExpress();
~pahooHeartRailsExpress();

std::wstring errmsg = L"";		//G[bZ[W
std::string webapi = "";		//߂ŎgpWebAPIURL

//Ŋw
pstations_t Pstations[__SIZE_PPOINTS];

bool isError(void);
std::wstring getError(void);
void resetError(void);
void setError(std::wstring msg);
std::string getwebapi(void);

int getResults_Heartrails(double latitude, double longitude);

};

//pahooHeartRailsExpress:IuWFNg
pahooHeartRailsExpress* pHR;

/**
 * RXgN^
 */
pahooHeartRailsExpress::pahooHeartRailsExpress() {
}

//fXgN^
pahooHeartRailsExpress::~pahooHeartRailsExpress() {
}

/**
 * G[
 * @param	Ȃ
 * @return	bool TRUE:ُ^FALSE:
*/
bool pahooHeartRailsExpress::isError(void) {
	return this->errmsg.length() > 0;
}

/**
 * G[bZ[W擾
 * @param	Ȃ
 * @return	wstring ݔĂG[bZ[W
*/
wstring pahooHeartRailsExpress::getError(void) {
	return this->errmsg;
}

/**
 * G[Zbg
 * @param	Ȃ
 * @return	Ȃ
*/
void pahooHeartRailsExpress::resetError(void) {
	errmsg = L"";
}

/**
 * G[Zbg
 * @param	wstring msg G[bZ[W
 * @return	Ȃ
*/
void pahooHeartRailsExpress::setError(wstring msg) {
	errmsg = msg;
}

/**
 * ߂ŎgpWebAPIURL擾
 * @param	Ȃ
 * @return	string URL
*/
string pahooHeartRailsExpress::getwebapi(void) {
	return this->webapi;
}

/**
 * HeartRails Express API KvȏzɊi[
 * @param	double latitude  ܓxiEnnj
 * @param	double longitude oxiEnnj
 * @return	int qbg^(-1)FG[
*/
int pahooHeartRailsExpress::getResults_Heartrails(double latitude, double longitude) {
	char lng[SIZE_BUFF + 1], lat[SIZE_BUFF + 1];

	snprintf(lng, SIZE_BUFF, "%.5f", longitude);
	snprintf(lat, SIZE_BUFF, "%.5f", latitude);
	this->webapi = "http://express.heartrails.com/api/xml?method=getStations&x=" + (string)lng + "&y=" + (string)lat;
	static string contents = "";
	bool res = readWebContents(this->webapi, UserAgent, &contents);
	if (res == FALSE) {
		this->errmsg = _SW("HeartRails Express API̐ڑG[܂");
		return (-1);
	}

	//z̏
	for (int i = 0; i < __SIZE_PPOINTS; i++) {
		this->Pstations[i].id = 0;
		this->Pstations[i].title = this->Pstations[i].line = this->Pstations[i].distance = L"";
		this->Pstations[i].latitude = this->Pstations[i].longitude = 0.0;
	}

	//XMLǂݍ
	int cnt = 0;
	try {
		std::stringstream ss;
		ss << contents;
		ptree pt;
		xml_parser::read_xml(ss, pt);

		//`FbN
		if (optional<string>str = pt.get_optional<string>("response.station")) {
		} else {
			this->errmsg = _SW("HeartRails Geo APỈG[܂");
			return (-1);
		}

		//XML
		try {
			for (auto it : pt.get_child("response")) {
				if (cnt >= __SIZE_PPOINTS) {
					break;
				}
				//ǂݔ΂
				if (it.first != "station") {
					continue;
				}
				//Ŋw
				if (optional<string>name = it.second.get_optional<string>("name")) {
					this->Pstations[cnt].title = _UW(name.value());
				}
				//ܓx
				if (optional<string>lat = it.second.get_optional<string>("y")) {
					this->Pstations[cnt].latitude = stod(lat.value());
				}
				//ox
				if (optional<string>lng = it.second.get_optional<string>("x")) {
					this->Pstations[cnt].longitude = stod(lng.value());
				}
				//H
				if (optional<string>line = it.second.get_optional<string>("line")) {
					this->Pstations[cnt].line = _UW(line.value());
				}
				//
				if (optional<string>distance = it.second.get_optional<string>("distance")) {
					this->Pstations[cnt].distance = _UW(distance.value());
				}
				//ʎq
				this->Pstations[cnt].id = {(char)(65 + cnt)};
				cnt++;
			}
		//XML߃G[
		} catch(ptree_bad_path& e) {
			this->errmsg = _SW("HeartRails Geo APǏG[܂");
			return (-1);
		}

	//ǂݍ݃G[
	} catch(xml_parser_error& e) {
		this->errmsg = _SW("HeartRails Geo API̐ڑG[܂");
		return (-1);
	}
	contents.clear();

	return cnt;
}

/**
 * n}ɕ\CtH[V쐬
 * @param	int cnt \CtH[V
 * @return	d폜̃CtH[V
 */
int makeInformation(int cnt) {
	//
	for (int i = 0; i < __SIZE_PPOINTS; i++) {
		pGC->Ppoints[i].latitude = pGC->Ppoints[i].longitude = 0.0;
		pGC->Ppoints[i].title = pGC->Ppoints[i].address = pGC->Ppoints[i].description = L"";
		pGC->Ppoints[i].icon = "";
	}

	//CtH[V쐬
	int j = -1;
	for (int i = 0; i < cnt; i++) {
		//O̒n_ƈܓxEox
		if ((i > 0)
			&& (pHR->Pstations[i].latitude == pHR->Pstations[i - 1].latitude)
			&& (pHR->Pstations[i].longitude == pHR->Pstations[i - 1].longitude)) {
			pGC->Ppoints[j].latitude  = pHR->Pstations[i].latitude;
			pGC->Ppoints[j].longitude = pHR->Pstations[i].longitude;
			pGC->Ppoints[j].description += L"<br />" + pHR->Pstations[i].title
				+ _SW(" (") + pHR->Pstations[i].line + _SW(") ")
				+ pHR->Pstations[i].distance;
		//ܓxEoxقȂ
		} else {
			j++;
			pGC->Ppoints[j].latitude  = pHR->Pstations[i].latitude;
			pGC->Ppoints[j].longitude = pHR->Pstations[i].longitude;
			pGC->Ppoints[j].description = pHR->Pstations[i].title
				+ _SW(" (") + pHR->Pstations[i].line + _SW(") ")
				+ pHR->Pstations[i].distance;
		}
		//ʎq̐U蒼
		pHR->Pstations[i].id = {(char)(65 + j)};
	}

	//d̍폜
	for (int i = j + 1; i < __SIZE_PPOINTS; i++) {
		pGC->Ppoints[i].latitude = pGC->Ppoints[i].longitude = 0.0;
		pGC->Ppoints[i].title = pGC->Ppoints[i].address = pGC->Ppoints[i].description = L"";
		pGC->Ppoints[i].icon = "";
	}

	return j + 1;
}

// n}\iuEUj ======================================================
/**
 * n}\pHTML
 * @param	int cnt \CtH[V
 * @return	string HTML
 */
string makeMapHTML(int cnt=0) {
	string script = pGC->makeMapLeaflet(MAP_ID, Longitude, Latitude, Zoom, Maptype, pGC->Ppoints, cnt);
	string html = (boost::format(R"(<!DOCTYPE html>
<html lang="ja">
<head>
<meta charset="SJIS">
<title>Ŋw</title>
<meta name="author" content="studio pahoo" />
<meta name="copyright" content="studio pahoo" />
<meta name="ROBOTS" content="NOINDEX,NOFOLLOW" />
<meta http-equiv="pragma" content="no-cache">
<meta http-equiv="cache-control" content="no-cache">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
%8%
</head>
<body>
<div id="%1%" style="width:%2%px; height:%3%px;"></div>
<form>
<input id="latitude"  type="hidden" value="%4%" />
<input id="longitude" type="hidden" value="%5%" />
<input id="zoom"      type="hidden" value="%6%" />
<input id="maptype"   type="hidden" value="%7%" />
</form>
</body>
</html>
)")
% MAP_ID						//n}ID
% MAP_WIDTH						//n}̕
% MAP_HEIGHT					//n}̍
% Latitude						//ܓx
% Longitude						//ox
% Zoom							//n}g嗦
% Maptype						//n}^Cv
% script						//n}`XNvg
).str();

	return html;
}

/**
 * G[bZ[W\pHTML
 * @param	Ȃ
 * @return	string HTML
 */
string makeErrorHTML(void) {
	string msg;
	if (pGC->isError()) {
		msg = _WS(pGC->getError());
	} else {
		msg = ErrorMessage;
	}
	return (boost::format(R"(<!DOCTYPE html>
<html lang="ja">
<head>
<meta charset="SJIS">
<title>G[</title>
<meta name="author" content="studio pahoo" />
<meta name="copyright" content="studio pahoo" />
<meta name="ROBOTS" content="NOINDEX,NOFOLLOW" />
<meta http-equiv="pragma" content="no-cache">
<meta http-equiv="cache-control" content="no-cache">
</head>
<body>
<p style="color:red; font-size:large;">%1%</p>
</body>
</html>
)")
% msg
).str();
}

/**
 * uEUERg[\
 * @param	char* tmpname ǂݍHTMLt@C
 * @param	int cnt \CtH[V
 * @return	Ȃ
 */
void viewBrowser(const char *tmpname, int cnt=0) {
	string html;
	string fname;
	ofstream ofs;

	//\pHTMLt@C쐬
	if ((ErrorMessage == "") && (! pGC->isError())) {
		html = makeMapHTML(cnt);
	} else {
		html = makeErrorHTML();
	}
	ofs.open(tmpname);
	ofs << html;
	ofs.close();

	fname = (string) tmpname;
	std::replace(fname.begin(), fname.end(), '\\', '/');

	if (isWeb2Ready()) {
		webView2->Reload();
	}
}

// Ŋwꗗ쐬iXgr[j =========================================
//Xgr[̗
enum {
	COL_ID,
	COL_TITLE,
	COL_LINE,
	COL_DISTANCE
};

/**
 * Ŋẅꗗ\t[쐬
 * @param	HWND hDlg  EBhEnh
 * @return	Ȃ
*/
void makeListViewFrame(HWND hWnd) {
	LVCOLUMNA lvcol;
	lvcol.mask = LVCF_TEXT | LVCF_SUBITEM | LVCF_WIDTH | LVCF_FMT;

	lvcol.cx = 50;
	lvcol.fmt = LVCFMT_CENTER;
	lvcol.pszText = (char *)"ID";
	SendMessage(hWnd, LVM_INSERTCOLUMNA, COL_ID, (WPARAM)&lvcol);
	lvcol.cx = 150;
	lvcol.fmt = LVCFMT_LEFT;
	lvcol.pszText = (char *)"w";
	SendMessage(hWnd, LVM_INSERTCOLUMNA, COL_TITLE, (WPARAM)&lvcol);
	lvcol.cx = 200;
	lvcol.fmt = LVCFMT_LEFT;
	lvcol.pszText = (char *)"H";
	SendMessage(hWnd, LVM_INSERTCOLUMNA, COL_LINE, (WPARAM)&lvcol);
	lvcol.cx = 100;
	lvcol.fmt = LVCFMT_RIGHT;
	lvcol.pszText = (char *)"";
	SendMessage(hWnd, LVM_INSERTCOLUMNA, COL_DISTANCE, (WPARAM)&lvcol);

	//r\
	DWORD dwStyle = ListView_GetExtendedListViewStyle(hWnd);
	dwStyle = dwStyle | LVS_EX_GRIDLINES | LVS_EX_ONECLICKACTIVATE;
	ListView_SetExtendedListViewStyle(hWnd, dwStyle);
}

/**
 * Ŋẅꗗ\
 * @param	HWND hDlg  EBhEnh
 * @return	Ȃ
*/
void makeListView(HWND hWnd) {
	LVITEMA item;

	//
	for (int i = 0; i < __SIZE_PPOINTS; i++) {
		item.iItem = i;
		SendMessage(hWnd, LVM_DELETEITEM, 0, (WPARAM)&item);
	}

	//f[^s
	for (int i = 0; i < __SIZE_PPOINTS; i++) {
		if (pHR->Pstations[i].id == 0) {
			break;
		}
		//ID
		item.mask = LVIF_TEXT;
		item.iItem = i;
		item.iSubItem = COL_ID;
		string s = {pHR->Pstations[i].id};
		item.pszText = (LPSTR)(s.c_str());
		SendMessage(hWnd, LVM_INSERTITEMA, 0,(WPARAM)&item);
		//w
		item.iSubItem = COL_TITLE;
		item.pszText = (LPSTR)_WS(pHR->Pstations[i].title).substr(0, MAX_LISTVIEWITEM).c_str();
		SendMessage(hWnd, LVM_SETITEMA, 0,(WPARAM)&item);
		//H
		item.iSubItem = COL_LINE;
		item.pszText = (LPSTR)_WS(pHR->Pstations[i].line).substr(0, MAX_LISTVIEWITEM).c_str();
		SendMessage(hWnd, LVM_SETITEMA, 0,(WPARAM)&item);
		//
		item.iSubItem = COL_DISTANCE;
		item.pszText = (LPSTR)_WS(pHR->Pstations[i].distance).substr(0, MAX_LISTVIEWITEM).c_str();
		SendMessage(hWnd, LVM_SETITEMA, 0,(WPARAM)&item);
	}
}

/**
 * ŊwCuEU\ƈꗗ\sD
 * @param	HWND hDlg  EBhEnh
 * @return	Ȃ
*/
void viewMapList(void) {
	int cnt = 0;

	//Ŋw
	cnt = pHR->getResults_Heartrails(Latitude, Longitude);
	if (cnt > 0) {
		cnt = makeInformation(cnt);
	}

	//uEUERg[ɕ\
	viewBrowser(tmpFname, cnt);

	//Ŋẅꗗ\
	makeListView(GetDlgItem(hParent, IDC_LISTVIEW_STATIONS));
}

// ۑERs[ =============================================================
/**
 * ꗗCSVt@CɕۑFۑ
 * @param	const char* fname ۑt@C
 * @return	Ȃ
 */
void __saveCSV(const char *fname) {
	char lng[SIZE_BUFF + 1], lat[SIZE_BUFF + 1];
	ofstream outputfile(fname);

	//x
	outputfile << "\"" << "ID" << "\",";
	outputfile << "\"" << "w" << "\",";
	outputfile << "\"" << "H" << "\",";
	outputfile << "\"" << "ܓx" << "\",";
	outputfile << "\"" << "ox" << "\",";
	outputfile << "\"" << "" << "\"" << endl;

	//f[^{
	for (int i = 0; i < __SIZE_PPOINTS; i++) {
		if (pHR->Pstations[i].id != 0) {
			snprintf(lng, SIZE_BUFF, "%.5f", pHR->Pstations[i].longitude);
			snprintf(lat, SIZE_BUFF, "%.5f", pHR->Pstations[i].latitude);
			outputfile << "\"" << pHR->Pstations[i].id << "\",";
			outputfile << "\"" << _WS(pHR->Pstations[i].title) << "\",";
			outputfile << "\"" << _WS(pHR->Pstations[i].line) << "\",";
			outputfile << "\"" << lat << "\",";
			outputfile << "\"" << lng << "\",";
			outputfile << "\"" << _WS(pHR->Pstations[i].distance) << "\"" << endl;
		}
		if (outputfile.bad()) {
			ErrorMessage = "CSVt@C݃G[";
			break;
		}
	}
	outputfile.close();
}

/**
 * ꗗCSVt@CɕۑFt@C_CAO
 * @param	Ȃ
 * @return	Ȃ
 */
void saveCSV(void) {
	static char fname[MAX_PATH + 1];
	strcpy(fname, SAVEFILE);
	OPENFILENAME of;

	//OPENFILENAME\̂̃TCYZbg
	memset(&of, 0, sizeof(OPENFILENAME));
	of.lStructSize = sizeof(OPENFILENAME);
	//_CAO{bNXLEBhEւ̃nh
	of.hwndOwner = hParent;
	of.lpstrFilter = TEXT("CSVt@C(*.csv;*.txt)\0*.csv;*.txt\0ׂẴt@C(*.txt)\0*.txt\0\0");
	//t@Ci[obt@̃AhX
	of.lpstrFile = (LPTSTR)fname; 
	//lpstrFileoŎw肳obt@̃TCY
	of.nMaxFile = MAX_PATH;
	of.Flags = OFN_OVERWRITEPROMPT;
	//ftHg̊gqi[obt@̃AhX
	of.lpstrDefExt = TEXT("csv");
	//R_CAO̕\
	GetSaveFileName(&of);
	//t@Cۑ
	__saveCSV(fname);
}

/**
 * Nbv{[hɃRs[镶𐶐
 * @param	Ȃ
 * @return	string Rs[镶
 */
string copyText(void) {
	char lng[SIZE_BUFF + 1], lat[SIZE_BUFF + 1];
	ostringstream oss;

	//x
	oss << "ID" << "\t";
	oss << "w" << "\t";
	oss << "H" << "\t";
	oss << "ܓx" << "\t";
	oss << "ox" << "\t";
	oss << "" << endl;

	//f[^{
	for (int i = 0; i < __SIZE_PPOINTS; i++) {
		if (pHR->Pstations[i].id != 0) {
			snprintf(lng, SIZE_BUFF, "%.5f", pHR->Pstations[i].longitude);
			snprintf(lat, SIZE_BUFF, "%.5f", pHR->Pstations[i].latitude);
			oss << pHR->Pstations[i].id << "\t";
			oss << _WS(pHR->Pstations[i].title) << "\t";
			oss << _WS(pHR->Pstations[i].line) << "\t";
			oss << lat << "\t";
			oss << lng << "\t";
			oss << _WS(pHR->Pstations[i].distance) << endl;
		}
	}
	return oss.str();
}


// o[W\_CAO =================================================
/**
 * CxgnhFo[W\_CAO
 * @param	HWND hDlg			EBhEEnh
 * @paramm	UINT uMsg			bZ[Wʎq
 * @param	WPARAM wParam		bZ[W̍ŏ̃p[^
 * @paramL	PARAM lParam		bZ[W2Ԗڂ̃p[^
 * @return	INT_PTR CALLBACK	TRUEFbZ[W^FALSEF
 */
INT_PTR CALLBACK processHelp(HWND hDlg, UINT uMsg,
					WPARAM wParam, LPARAM lParam) {
	string help;

	switch (uMsg) {
	//_CAO
	case WM_INITDIALOG:
		CenterWindow(hDlg);
		setStrEditBox(hDlg, IDC_TEXT_HELP, Version);
		break;

		//{^
	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		//s
		case IDC_BUTTON_OK:
			EndDialog(hDlg, 0);
			break;
		default:
			return 1;
		}
		break;
		//vOI
	case WM_CLOSE:
		EndDialog(hDlg, 0);
		break;
	}
	return 0;
}

/**
 * wvE_CAO쐬
 * @param  HWND hDlg		eEBhEEnh
 * @param  DLGPROC handler	CxgEnh
 * @return Ȃ
 */
void createHelp(HWND hDlg, DLGPROC handler) {
	DialogBox(hInst, MAKEINTRESOURCE(IDD_DIALOG_VER), hDlg, (DLGPROC) handler);
}

// WebView2p֐Q ======================================================
/**
 * WebView2F_CAO
 * @param	HWND hDlg	eEBhEEnh
 * @return	Ȃ
*/
void initDialog(HWND hDlg) {
	HICON hIcon;
	hIcon = (HICON)LoadImage(hInst, MAKEINTRESOURCE(IDI_ICON), IMAGE_ICON, 16, 16, 0);
	SendMessage(hDlg, WM_SETICON, ICON_SMALL, (LPARAM)hIcon);
	ErrorMessage = "";

	//J[\v
	SetCursor(LoadCursor(NULL, IDC_WAIT));
	//IvVǂݍ
	loadParameter();
	//AvP[VEEBhEړ
	SetWindowPos(hDlg, NULL, hParent_X, hParent_Y, 0, 0, (SWP_NOSIZE | SWP_NOZORDER | SWP_NOOWNERZORDER));

	//e|Et@C擾
	getTempFname(tmpFname);
	size_t wLen = 0;
	mbstowcs_s(&wLen, wUri, MAX_PATH * 2, tmpFname, MAX_PATH);
	//WebView2
	hWebView2 = createWebView2(hInst, hDlg, 10, 50, MAP_WIDTH + 30, MAP_HEIGHT + 30, wUri);
	//Ŋẅꗗ\t[쐬
	makeListViewFrame(GetDlgItem(hDlg, IDC_LISTVIEW_STATIONS));

	//bZ[WE[v
	MSG msg;
	static bool flagWebView2 = false;
	while (GetMessage(&msg, nullptr, 0, 0)) {
		if (msg.message == WM_QUIT) {
			//IvVۑ
			//saveOption();
			DestroyWindow(hDlg);
		}
		TranslateMessage(&msg);
		DispatchMessage(&msg);
		if (!flagWebView2 && isWeb2Ready()) {
			//J[\v
			SetCursor(LoadCursor(NULL, IDC_WAIT));
			//uEU\ƈꗗ\
			viewMapList();
			flagWebView2 = true;
		}
	}
}

/**
 * WebView2nhD
 * selectAction̒lɂēςB
 * @param	char* result	JavaScriptInhnf[^
 * @return	Ȃ
*/
void execScriptCompleted(string result) {
	double lat = 0, lng = 0;
	int zm = 0;
	string mt;

	//p[^ǂݍ
	vector<string> tokens;
	split(tokens, result, is_any_of(",\""));
	int cnt = 0;
	for (string ss: tokens) {
		switch (cnt) {
			case 1:
				lng = stod(ss);
				break;
			case 2:
				lat = stod(ss);
				break;
			case 3:
				zm = stoi(ss);
				break;
			case 4:
				mt = ss;
				break;
		}
		cnt++;
	}

	switch (selectAction) {
		//ܓxEox擾ăuEUɕ\
		case eAction::GetLatLong:
			Longitude = lng;
			Latitude  = lat;
			//uEU\ƈꗗ\
			viewMapList();
			break;
		//g嗦E}bv^Cv擾ăuEUɕ\
		case eAction::GetZoomType:
			Zoom = zm;
			Maptype = mt;
			//uEU\ƈꗗ\
			viewMapList();
			break;
		//ܓxEoxEg嗦E}bv^Cv擾ăuEUɕ\
		case eAction::GetLatLongZoomType:
			Longitude = lng;
			Latitude  = lat;
			Zoom = zm;
			Maptype = mt;
			//uEU\ƈꗗ\
			viewMapList();
			break;
		//vOID
		default:
			Longitude = lng;
			Latitude  = lat;
			Zoom = zm;
			Maptype = mt;
			//e|Et@C폜D
			remove(tmpFname);
			//p[^ۑD
			saveParameter();
			//vOI
			EndDialog(hParent, 0);
			DestroyWindow(hParent);
			break;
	}
//	cout << "Longitude: " << Longitude << endl;
//	cout << "Latitude: " << Latitude << endl;
//	cout << "Zoom: " << Zoom << endl;
//	cout << "Maptype: " << Maptype << endl;
}

/**
 * WebView2FJavaScriptInh
 * @param	HWND hDlg			eEBhEEnh
 * @paramm	UINT uMsg			bZ[Wʎq
 * @param	WPARAM wParam		bZ[W̍ŏ̃p[^
 * @paramL	PARAM lParam		bZ[W2Ԗڂ̃p[^
 * @return	INT_PTR CALLBACK	TRUEFbZ[W^FALSEF
*/
class MyScriptCompletedHandler : public ICoreWebView2ExecuteScriptCompletedHandler {
public:
	HRESULT STDMETHODCALLTYPE Invoke(HRESULT error, PCWSTR result) override {
		if (SUCCEEDED(error)) {
			//PCWSTR  char* ϊ
			int requiredSize = WideCharToMultiByte(CP_UTF8, 0, result, -1, nullptr, 0, nullptr, nullptr);
			char* buffer = new char[requiredSize];
			WideCharToMultiByte(CP_UTF8, 0, result, -1, buffer, requiredSize, nullptr, nullptr);
			std::string res(buffer);
			//JavaScriptIɎs֐
			execScriptCompleted(res);
		}
		return S_OK;
	}

	HRESULT STDMETHODCALLTYPE QueryInterface(REFIID riid, void** ppvObject) override {
		return E_NOINTERFACE;
	}

	ULONG STDMETHODCALLTYPE AddRef(void) override {
		return 1;
	}

	ULONG STDMETHODCALLTYPE Release(void) override {
		return 1;
	}
};

// WebView2JavaScriptsDOMvf擾
MyScriptCompletedHandler* scriptCompletedHandler = new MyScriptCompletedHandler();

/**
 * WebView2ŃXNvgsCselectActionŎw肵ANVsD
 * @param	Ȃ
 * @return	Ȃ
*/
void execScriptAndAction(void) {
	//vOIɎsJavaScript
	LPCWSTR js = L"document.getElementById('longitude').value + ',' + document.getElementById('latitude').value + ',' + document.getElementById('zoom').value + ',' + document.getElementById('maptype').value;";

	webView2->ExecuteScript(js, scriptCompletedHandler);
}

// CEBhE ==========================================================
/**
 * CxgnhFCEBhE
 * @param	HWND hDlg			eEBhEEnh
 * @paramm	UINT uMsg			bZ[Wʎq
 * @param	WPARAM wParam		bZ[W̍ŏ̃p[^
 * @paramL	PARAM lParam		bZ[W2Ԗڂ̃p[^
 * @return	INT_PTR CALLBACK	TRUEFbZ[W^FALSEF
 */
INT_PTR CALLBACK processMain(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam) {
	wstring val;
	wstring wid;

	switch (uMsg) {
	//_CAO
	case WM_INITDIALOG:
		break;

	//{^
	case WM_COMMAND:
		if ((ErrorMessage != "") | pGC->isError()) {
			break;
		}
		switch (LOWORD(wParam)) {
		//
		case IDM_EXEC:
		case IDC_BUTTON_EXEC:
			//J[\v
			SetCursor(LoadCursor(NULL, IDC_WAIT));
			//L[΃WIR[hAPIĂяo
			Query = getStrEditBox(hDlg, IDC_EDIT_QUERY);
			if (Query.length() > 0) {
				if (pGC->searchPoints(_SW(Query), UserAgent, 0) > 0) {
					Longitude = pGC->Ppoints[0].longitude;
					Latitude  = pGC->Ppoints[0].latitude;
				}
				//uEU\ƈꗗ\
				selectAction = eAction::GetZoomType;
				execScriptAndAction();
			} else {
				//uEU\ƈꗗ\
				selectAction = eAction::GetLatLongZoomType;
				execScriptAndAction();
			}
			//G[EZbg
			ErrorMessage = "";
			pGC->resetError();
			break;
		//Zbg
		case IDC_BUTTON_RESET:
		case IDM_RESET:
			setStrEditBox(hDlg, IDC_EDIT_QUERY, "");
			ErrorMessage = "";
			pGC->resetError();
			break;
		//ۑ
		case IDC_BUTTON_SAVE:
		case IDM_SAVE:
			saveCSV();
			break;
		//GoogleAPIL[ۑ
		case IDM_GOOGLE_APIKEY:
			createSetAPIkey(hDlg, LABEL_GOOGLE_API, FNAME_GOOGLE_API, URL_GOOGLE_API, &pGC->GoogleAPIkey);
			pGC->readGoogleApiKey();
			//G[EZbg
			ErrorMessage = "";
			pGC->resetError();
			//GoogleAPIL[o^ȂftHg̃}bv^Cvɖ߂D
			Maptype = pGC->isGoogleApiKey() ? "GMRD" : DEF_MAPTYPE;
			//uEUERg[ɕ\
			viewBrowser(tmpFname);
			break;
		//Yahoo!AvP[VIDۑ
		case IDM_YAHOO_APIKEY:
			createSetAPIkey(hDlg, LABEL_YAHOO_API, FNAME_YAHOO_API, URL_YAHOO_API, &pGC->YahooAPIkey);
			//G[EZbg
			ErrorMessage = "";
			pGC->resetError();
			//uEUERg[ɕ\
			viewBrowser(tmpFname);
			break;
		//ݒNA{AvI
		case IDM_CLEAR_PARAMETER:
			delParameter();
			//e|Et@C폜
			remove(tmpFname);
			EndDialog(hDlg, 0);
			return 0;
			break;
		//wv
		case IDM_HELP:
			ShellExecute(hDlg, _T("open"), _T(HELPFILE), NULL, NULL, SW_RESTORE);
			break;
		//o[W\
		case IDM_VERSION:
			createHelp(hDlg, processHelp);
			break;
		//TCg
		case IDM_PAHOO:
			ShellExecute(NULL, _T("open"), _T(REFERENCE), NULL, NULL, SW_RESTORE);
			break;
		//Rs[
		case IDM_COPY:
		case IDC_BUTTON_COPY:
			setClipboardData(copyText());
			break;
		//؂
		case IDM_DELETE:
			setStrEditBox(hDlg, IDC_EDIT_QUERY, "");
			break;
		//vOI
		case IDM_QUIT:
			selectAction = eAction::Finish;
			execScriptAndAction();
			return 0;
		default:
			return 0;
		}
		break;

	//vOI
	case WM_CLOSE:
		selectAction = eAction::Finish;
		execScriptAndAction();
		return 0;
	}
	return 0;
}

// CEvO =======================================================
/**
 * WindowsCvO
 * @param	HINSTANCE hInstance			CX^Xnh
 * @paramm	HINSTANCE hPrevInstance		gp(NULL)FWin16̖c
 * @param	LPSTR lpCmdLine				R}hC
 * @paramL	int nShowCmd				EBhE̕\@
 * @return	int ^[R[h
 */
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nShowCmd) {
	LoadLibrary("RICHED20.DLL");

	//UserAgent
	static OSVERSIONINFOEX os;
	GetVersion2(&os);
	UserAgent = (string)"Mozilla/5.0 (" + APPNAME + "/"
		+ APPVERSION + "/" + MAKER
		+ ", Windows NT " + to_string(os.dwMajorVersion) + "."
		+ to_string(os.dwMinorVersion) + ")";

	//pahooGeocodeIuWFNg
	pGC = new pahooGeocode(APPNAME);
	//pahooHeartRailsExpressIuWFNg
	pHR = new pahooHeartRailsExpress();

	//CE_CAO
	HWND hDlg = CreateDialog(hInstance, MAKEINTRESOURCE(IDD_MAIN), NULL, (DLGPROC)processMain);
	hInst = hInstance;
	hParent = hDlg;
	//CE_CAOD
	initDialog(hDlg);

	//IuWFNg
	delete pGC;
	delete pHR;

	return 0;
}

/*
 ** o[WAbv =====================================================
 *
 * @version 2.1.1 2024/08/17  gpCuXV
 * @version 2.1.0 2024/05/03  API͏
 * @version 2.0.0 2024/04/28  EdgeuEUΉC64rbgΉ
 * @version 1.1.4 2024/03/30  gpCXV
 * @version 1.1.3 2023/11/23  gpCXV
 * @version 1.1.2 2023/07/08  gpCXV
 * @version 1.1.1 2023/04/01  gpCXV
 * @version 1.1.0 2022/09/23  UserAgentǉCEBhEʒuۑCCuXV
 * @version 1.0   2020/10/03  
 */
